# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
# Copyright 2013 Canonical
#
# This program is free software: you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 3, as published
# by the Free Software Foundation.


def get_nearest_parent_matching_type(child, desired_type):
    """Climb down the widget tree, return first instance of desired_type"""
    while type(child).__name__ != desired_type:
        parent = child.get_parent()
        if type(child).__name__ == 'AddressBookApp':
            # we reached the root and found nothing
            return None
        else:
            child = parent
    return child
